﻿using Newtonsoft.Json;
using Syncfusion.EJ.PdfViewer;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;

namespace PDFViewDemo.Controllers
{
    public class PDFDemoController : Controller
    {
        //
        // GET: /PDFDemo/

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Load(jsonObjects results)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            var jsonResult = JsonConverterstring(results);
            //load the multiple document from client side 
            if (jsonResult.ContainsKey("newFileName"))
            {
                var name = jsonResult["newFileName"];
                var pdfName = name.ToString();
                helper.Load(pdfName);
            }
            else
            {
                //Initially load the PDF document from the data folder.
                if (jsonResult.ContainsKey("isInitialLoading"))
                {
                    helper.Load(Helper.GetFilePath(""));
                }
            }
            return Content(JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult)));
        }
        public Dictionary<string, string> JsonConverterstring(jsonObjects results)
        {
            Dictionary<string, object> resultObjects = new Dictionary<string, object>();
            resultObjects = results.GetType().GetProperties(BindingFlags.Instance | BindingFlags.Public)
                .ToDictionary(prop => prop.Name, prop => prop.GetValue(results, null));
            var emptyObjects = (from kv in resultObjects
                                where kv.Value != null
                                select kv).ToDictionary(kv => kv.Key, kv => kv.Value);
            Dictionary<string, string> jsonResult = emptyObjects.ToDictionary(k => k.Key, k => k.Value.ToString());
            return jsonResult;
        }
        public JsonResult Download(jsonObjects result)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            var jsonResult = JsonConverterstring(result);
            return Json(helper.GetDocumentData(jsonResult));
        }
        public ActionResult FileUpload(jsonObjects result)
        {
            PdfViewerHelper helper = new PdfViewerHelper();
            var jsonResult = JsonConverterstring(result);
            if (jsonResult.ContainsKey("uploadedFile"))
            {
                var fileurl = jsonResult["uploadedFile"];
                byte[] byteArray = Convert.FromBase64String(fileurl);
                MemoryStream stream = new MemoryStream(byteArray);
                helper.Load(stream);
            }
            return Content(JsonConvert.SerializeObject(helper.ProcessPdf(jsonResult)));
        }
        [HttpPost]
        public ActionResult GetDocument(jsonObjects result)
        {
            string constr = ConfigurationManager.ConnectionStrings["PdfData"].ConnectionString;
            SqlConnection con = new SqlConnection(constr);
            var jsonResult = JsonConverterstring(result);
            var fileId = jsonResult["documentId"];
            var CommandText = "select Data from PdfDataTable where DocumentID='" + fileId + "'";
            SqlCommand cmd = new SqlCommand(CommandText);
            cmd.Connection = con;
            con.Open();
            var read = cmd.ExecuteReader();
            read.Read();
            var dataString = read.GetValue(0).ToString();
            con.Close();
            return Content(dataString);
        }
    }
    public class jsonObjects
    {
        public string viewerAction { get; set; }
        public string pageindex { get; set; }
        public string controlId { get; set; }
        public string isInitialLoading { get; set; }
        public string id { get; set; }
        public string isPageScrolled { get; set; }
        public string uploadedFile { get; set; }
        public string newFileName { get; set; }
        public string file { get; set; }
        public string enableOfflineMode { get; set; }
        public string savetextMarkupAnnotation { get; set; }
        public string existingAnnotations { get; set; }
        public string savedFields { get; set; }
        public string documentId { get; set; }
    }
    public class Helper
    {
        public static string GetFilePath(string path)
        {
            string _dataPath = new System.IO.DirectoryInfo(HttpContext.Current.Request.PhysicalApplicationPath
                + "\\Data").FullName;
            _dataPath += @"\" + path;
            return _dataPath;
        }
    }

}
